Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.414
diff -u -r1.414 chan_zap.c
--- channels/chan_zap.c	5 Mar 2005 02:08:37 -0000	1.414
+++ channels/chan_zap.c	9 Mar 2005 07:22:15 -0000
@@ -1574,7 +1574,7 @@
 	int x, res, index;
 	char *c, *n, *l;
 #ifdef ZAPATA_PRI
-	char *s=NULL;
+	char *s=NULL, *bs;
 #endif
 	char dest[256]; /* must be same length as p->dialdest */
 	ast_mutex_lock(&p->lock);
@@ -1867,7 +1867,28 @@
 		p->digital = ast_test_flag(ast,AST_FLAG_DIGITAL);
 		pri_sr_set_channel(sr, p->bearer ? PVT_TO_CHANNEL(p->bearer) : PVT_TO_CHANNEL(p), 
 								p->pri->nodetype == PRI_NETWORK ? 0 : 1, 1);
-		pri_sr_set_bearer(sr, p->digital ? PRI_TRANS_CAP_DIGITAL : PRI_TRANS_CAP_SPEECH, 
+		bs = pbx_builtin_getvar_helper(ast,"CALLTYPE");
+		x = p->digital ? PRI_TRANS_CAP_DIGITAL : PRI_TRANS_CAP_SPEECH;
+		if (c)
+		{
+			if (!strcasecmp(bs, "SPEECH"))
+				x = PRI_TRANS_CAP_SPEECH;
+			else if (!strcasecmp(bs, "DIGITAL")) {
+				x = PRI_TRANS_CAP_DIGITAL;
+			else if (!strcasecmp(bs, "RESTRICTED_DIGITAL"))
+				x = PRI_TRANS_CAP_RESTRICTED_DIGITAL;
+			else if (!strcasecmp(bs, "31KAUDIO"))
+				x = PRI_TRANS_CAP_3_1K_AUDIO;
+			else if (!strcasecmp(bs, "7KAUDIO"))
+				x = PRI_TRANS_CAP_7K_AUDIO;
+			else if (!strcasecmp(bs, "VIDEO"))
+				x = PRI_TRANS_CAP_VIDEO;
+		}
+/*
+		if (option_verbose > 2)
+			ast_verbose(VERBOSE_PREFIX_3 "Calltype for %s is %s, bearer capability is %x\n", ast->name, bs ? bs : "(null)", x);
+*/
+		pri_sr_set_bearer(sr, x, 
 					(p->digital ? -1 : 
 						((p->law == ZT_LAW_ALAW) ? PRI_LAYER_1_ALAW : PRI_LAYER_1_ULAW)));
  		dp_strip = 0;
